Audacious - OLD, PLEASE USE GITHUB DISCUSSIONS/ISSUES - Bug #817

Crash on invalid tuple D-Bus request
August 09, 2018 02:31 - Tom Thorogood

Status: Closed Start date: August 09, 2018
Priority: Major Due date:

Assignee: % Done: 100%
Category: core Estimated time: 0.00 hour
Target version: 3.10.1

Affects version: 3.10

Description

| was able to trigger an easily reproducible crash through the D-Bus interface. The org.atheme.audacious.SongTuple method does
not valid the requested tuple in do_song_tuple before calling get_value_type. This triggers an assert in get_value_type, but could
potentially still crash otherwise. Instead of a crash, I'd expect either an empty string or an error to be returned.

The crash can be reproduced with:

dbus—-send —--session —-print-reply —--dest=org.atheme.audacious /org/atheme/audacious org.atheme.aud
acious.SongTuple uint32:0 string:x

It crashes with the following backtrace:

#0 O0x00007ffffe638afeb in raise () at /l1lib64/libc.so.6
#1 0x00007ffff63755cl in abort () at /1lib64/libc.so.6
#2 0x00007f£f££f£6375491 in _nl_load_domain.cold.0 () at /lib64/libc.so.6
#3 0x00007ffff6383752 in () at /l1lib64/libc.so.6
#4 O0x00007ffff7bbl1ld26 in Tuple::get_value_type (Tuple::Field) const (this=this@entry=0x7fffffffc97
0, field=field@entry=Tuple::Invalid) at tuple.cc:450
#5 0x000055555555f66d in do_song_tuple (_ObjAudacious*, _GDBusMethodInvocation*, unsigned int, cha
r const*) (obj=0x5555557a4cel, invoc=0x555555cf£3260, pos=0, key=<optimized out>)
at dbus-server.cc:644
#6 0x00007ffff5a6e03e in ffi_call_unix64 () at /1lib64/libffi.so.6
#7 0x00007ffff5a6d9ff in ffi_call () at /lib64/libffi.so.6
#8 0x00007f££f£f73795a5 in g_cclosure_marshal_generic () at /l1lib64/libgobject-2.0.s0.0
#9 0x00007f£ff£f7378add in g_closure_invoke () at /1lib64/libgobject-2.0.s0.0
#10 0x00007ffff738bf43 in signal_emit_unlocked_R () at /lib64/libgobject-2.0.s0.0
#11 0x00007fff£f739419f in g_signal_emitv () at /l1lib64/libgobject-2.0.s0.0
#12 0x000055555556a0la in _obj_audacious_skeleton_handle_method_call (connection=<optimized out>,
sender=<optimized out>, object_path=<optimized out>, interface_name=0x7£££fd4018£f80 "org.atheme.aud
acious", method_name=0x7f£f£fd40193a0 "SongTuple", parameters=<optimized out>, invocation=0x555555cf
3260, user_data=0x5555557a4cel) at aud-dbus.c:15178
#13 0x00007£f£f£f£f76970f6 in g_dbus_interface_method_dispatch_helper () at /1lib64/libgio-2.0.s0.0
#14 0x00007f£ff£f767eb50 in call_in_idle_cb () at /1lib64/libgio-2.0.s0.0
#15 0x00007ffff709%alcb in g_idle_dispatch () at /1ib64/1ibglib-2.0.s0.0
#16 0x00007ffff709d8ad in g_main_context_dispatch () at /1ib64/1ibglib-2.0.s0.0
#17 0x00007f£ff£f709dc78 in g _main_context_iterate.isra () at /1lib64/1libglib-2.0.s0.0
#18 0x00007f£f£f£f709dfa2 in g _main_loop_run () at /lib64/1libglib-2.0.s0.0
#19 0x00007fffcd32695f in gtk_main () at /1ib64/libgtk-x11-2.0.s0.0
#20 0x00007ffff7b9c85e in interface_run() () at interface.cc:163
#21 0x00007ffff7baffd6 in aud_run() () at runtime.cc:323
#22 0x000055555555e774 in main (argc=<optimized out>, argv=<optimized out>) at main.cc:395
#23 0x00007ff£f£f637724b in _ libc_start_main () at /lib64/libc.so.6
#24 0x000055555555ed7a in _start () at main.cc:410
https://github.com/audacious-media-player/audacious/blob/cdcc92f29f4834f3bdd51b1894b995a585efaf12/src/audacious/dbus-server.cc#L635

I'm running into this with Audacious 3.10-beta1 (from https: r.fedorainfracloud.or rs/mschwen ious-next/).

History

#1 - August 19, 2018 18:17 - John Lindgren
- % Done changed from 0 to 100

- Target version changed from 3.10 to 3.10.1
- Status changed from New to Closed

- Category set to core

Fixed:
https://github.com/audacious-media-player/audacious/commit/1528e780825b1fc49639ea16d332c5752051dab7

#2 - August 19, 2018 18:19 - John Lindgren
- Affects version 3.10 added
